package schedframe.scheduling.manager.resources;

import java.util.List;
import java.util.Map;
import java.util.Properties;

import schedframe.exceptions.ResourceException;
import schedframe.resources.ResourceStatus;
import schedframe.resources.ResourceType;
import schedframe.resources.computing.ComputingResource;
import schedframe.resources.units.ResourceUnit;
import schedframe.resources.units.ResourceUnitName;
import schedframe.scheduling.Scheduler;

public interface ResourceManager {

	public boolean areResourcesAchievable(ResourceType type);
	
	public List<? extends ComputingResource> getResourcesOfType(ResourceType type);

	public ComputingResource getResourceByName(String resourceName);

	public List<? extends ComputingResource> getResourcesByTypeWithStatus(ResourceType type, ResourceStatus status);
	
	public Map<ResourceUnitName, List<ResourceUnit>> getSharedResourceUnits();
	
	public List<ResourceUnit> getDistributedResourceUnits(ResourceUnitName unitName);
	
	public List<? extends ComputingResource> filterResources(Properties properties);
	
	public List<Scheduler> getSchedulers();

	public String getSchedulerName(String resourceName);
}
